from read import readInteger, readPositive

def is_valid_option(number):
    return number >= 0 and number <= 5

def menu():
    print("Select option")
    print("1. Add book")
    print("2. List books by title")
    print("3. List books by author")
    print("4. Search book")
    print("5. Count copies")
    print("0. Quit")
    
    #option = readInteger("Your option", is_valid_option, "Invalid option given")
    option = readInteger("Your option", lambda n: n >= 0 and n <=5, "Invalid option given")
    return option

def read_book():
    book = {
        'author': input("Author: "),
        'title': input("Title: "),        
        'copies': readPositive("Number of copies")
    }
    
    return book
    
def print_books(books):
    for book in books:
        print("{0}: {1}, {2}db".format(book['author'], book['title'], book['copies']))
        
def search_books(books):
    expr = input("Search for: ").lower()
    
    # Version 1
    result = []
    for book in books:
        if expr in book['title'].lower() or expr in book['author'].lower():
            result.append(book)
    
    # Version 2
    #result = [book for book in books if expr in book['title'].lower() or expr in book['author'].lower()]
            
    return result

def count_books(books):
    # Version #1
    count = 0
    for book in books:
        count += book['copies']
        
    # Version 2
    #count = sum([book['copies'] for book in books])
    
    # Version 3
    #count = sum(map(lambda b: b['copies'], books))
    
    return count
    

# The "main" program
books = []

option = menu()
while option > 0:
    if option == 1:
        print("Add book")
        new_book = read_book()
        books.append(new_book)
    elif option == 2:
        print("List books by title")
        sorted_books = sorted(books, key = lambda item: item['title'])
        print_books(sorted_books)
    elif option == 3:
        print("List books by author")
        sorted_books = sorted(books, key = lambda item: item['author'])
        print_books(sorted_books)
    elif option == 4:
        print("Search book")
        filtered_books = search_books(books)
        print_books(filtered_books)
    elif option == 5:
        book_count = count_books(books)
        print("Number of copies: {0}".format(book_count))
    
    print()
    option = menu()
